import * as i0 from '@angular/core';
import { output, Component, ChangeDetectionStrategy, input, signal, inject, ChangeDetectorRef, ViewChild } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';

class DefaultIndicatorButtonComponent {
    constructor() {
        this.buttonClicked = output();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.4", ngImport: i0, type: DefaultIndicatorButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.2.4", type: DefaultIndicatorButtonComponent, isStandalone: true, selector: "ng-scroll-view-default-indicator-button", outputs: { buttonClicked: "buttonClicked" }, ngImport: i0, template: `
    <button class="default-button" (click)="buttonClicked.emit()">
      <span>There is more content</span>
    </button>
  `, isInline: true, styles: ["button{border:none;font-size:.8rem;font-weight:500;padding:.4rem .6rem;background-color:#444;color:#fff;border-radius:1rem;margin-bottom:.4rem}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.4", ngImport: i0, type: DefaultIndicatorButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ng-scroll-view-default-indicator-button', template: `
    <button class="default-button" (click)="buttonClicked.emit()">
      <span>There is more content</span>
    </button>
  `, standalone: true, changeDetection: ChangeDetectionStrategy.OnPush, styles: ["button{border:none;font-size:.8rem;font-weight:500;padding:.4rem .6rem;background-color:#444;color:#fff;border-radius:1rem;margin-bottom:.4rem}\n"] }]
        }] });

class ScrollViewWithIndicatorComponent {
    constructor() {
        this.scrollState = output();
        this.indicatorButton = input.required();
        this.isOverflowing = signal(false);
        this.isAtBottom = signal(false);
        this.cdr = inject(ChangeDetectorRef);
        this.resizeObserver = null;
    }
    ngAfterViewInit() {
        this.resizeObserver = new ResizeObserver(() => {
            this.updateOverflowState();
            this.updateScrollState();
            this.cdr.detectChanges();
        });
        this.resizeObserver.observe(this.contentWrapper.nativeElement);
    }
    ngOnDestroy() {
        this.resizeObserver?.disconnect();
    }
    /**
     * Manually scrolls the content-container to the bottom
     */
    scrollToBottom() {
        this.contentWrapper.nativeElement.scrollTop = this.contentWrapper.nativeElement.scrollHeight;
    }
    /**
     * If the user scrolled all the way to the end of the container,
     * the indicator button can be hidden
     */
    onScroll() {
        this.updateScrollState();
    }
    updateOverflowState() {
        const element = this.contentWrapper.nativeElement;
        const maxScroll = element.scrollHeight - element.offsetHeight;
        this.isOverflowing.set(element.offsetHeight < element.scrollHeight && element.scrollTop < maxScroll);
    }
    updateScrollState() {
        const element = this.contentWrapper.nativeElement;
        const maxScroll = element.scrollHeight - element.offsetHeight;
        this.isAtBottom.set(element.scrollTop + 1 >= maxScroll);
        this.scrollState.emit(Math.round((100 / maxScroll) * (element.scrollTop + 1)));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.4", ngImport: i0, type: ScrollViewWithIndicatorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.1.0", version: "18.2.4", type: ScrollViewWithIndicatorComponent, isStandalone: true, selector: "ng-scroll-view-with-indicator", inputs: { indicatorButton: { classPropertyName: "indicatorButton", publicName: "indicatorButton", isSignal: true, isRequired: true, transformFunction: null } }, outputs: { scrollState: "scrollState" }, viewQueries: [{ propertyName: "contentWrapper", first: true, predicate: ["contentWrapper"], descendants: true }], ngImport: i0, template: "<div class=\"content-wrapper\" #contentWrapper (scroll)=\"onScroll()\">\n  <ng-content />\n</div>\n\n<div class=\"scroll-indicator\" *ngIf=\"isOverflowing() && !isAtBottom()\">\n  <ng-container *ngIf=\"indicatorButton(); else defaultButton\" [ngTemplateOutlet]=\"indicatorButton()\" />\n\n  <ng-template #defaultButton>\n    <ng-scroll-view-default-indicator-button (buttonClicked)=\"scrollToBottom()\" />\n  </ng-template>\n</div>\n", styles: [":host{height:100%;max-height:100%;position:relative;min-height:0;display:flex}.content-wrapper{flex:1;max-height:100%;min-height:0;overflow-y:auto;box-sizing:border-box}.scroll-indicator{position:absolute;bottom:0;left:0;right:0;display:flex;justify-content:center}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: DefaultIndicatorButtonComponent, selector: "ng-scroll-view-default-indicator-button", outputs: ["buttonClicked"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.4", ngImport: i0, type: ScrollViewWithIndicatorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ng-scroll-view-with-indicator', imports: [CommonModule, DefaultIndicatorButtonComponent], standalone: true, changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"content-wrapper\" #contentWrapper (scroll)=\"onScroll()\">\n  <ng-content />\n</div>\n\n<div class=\"scroll-indicator\" *ngIf=\"isOverflowing() && !isAtBottom()\">\n  <ng-container *ngIf=\"indicatorButton(); else defaultButton\" [ngTemplateOutlet]=\"indicatorButton()\" />\n\n  <ng-template #defaultButton>\n    <ng-scroll-view-default-indicator-button (buttonClicked)=\"scrollToBottom()\" />\n  </ng-template>\n</div>\n", styles: [":host{height:100%;max-height:100%;position:relative;min-height:0;display:flex}.content-wrapper{flex:1;max-height:100%;min-height:0;overflow-y:auto;box-sizing:border-box}.scroll-indicator{position:absolute;bottom:0;left:0;right:0;display:flex;justify-content:center}\n"] }]
        }], propDecorators: { contentWrapper: [{
                type: ViewChild,
                args: ['contentWrapper']
            }] } });

/**
 * Generated bundle index. Do not edit.
 */

export { ScrollViewWithIndicatorComponent };
//# sourceMappingURL=angular-overflow-indicator.mjs.map
